// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package members

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/blaze/blaze_models"
)

// GetMemberReader is a Reader for the GetMember structure.
type GetMemberReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetMemberReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetMemberOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetMemberUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetMemberForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetMemberNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetMemberInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetMemberOK creates a GetMemberOK with default headers values
func NewGetMemberOK() *GetMemberOK {
	return &GetMemberOK{}
}

/*GetMemberOK handles this case with default header values.

Product was successfully retrieved
*/
type GetMemberOK struct {
	Payload *blaze_models.MemberResponse
}

func (o *GetMemberOK) Error() string {
	return fmt.Sprintf("[GET /partner/members/{memberId}][%d] getMemberOK  %+v", 200, o.Payload)
}

func (o *GetMemberOK) GetPayload() *blaze_models.MemberResponse {
	return o.Payload
}

func (o *GetMemberOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(blaze_models.MemberResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetMemberUnauthorized creates a GetMemberUnauthorized with default headers values
func NewGetMemberUnauthorized() *GetMemberUnauthorized {
	return &GetMemberUnauthorized{}
}

/*GetMemberUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetMemberUnauthorized struct {
	Payload *blaze_models.Error
}

func (o *GetMemberUnauthorized) Error() string {
	return fmt.Sprintf("[GET /partner/members/{memberId}][%d] getMemberUnauthorized  %+v", 401, o.Payload)
}

func (o *GetMemberUnauthorized) GetPayload() *blaze_models.Error {
	return o.Payload
}

func (o *GetMemberUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(blaze_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetMemberForbidden creates a GetMemberForbidden with default headers values
func NewGetMemberForbidden() *GetMemberForbidden {
	return &GetMemberForbidden{}
}

/*GetMemberForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetMemberForbidden struct {
	Payload *blaze_models.Error
}

func (o *GetMemberForbidden) Error() string {
	return fmt.Sprintf("[GET /partner/members/{memberId}][%d] getMemberForbidden  %+v", 403, o.Payload)
}

func (o *GetMemberForbidden) GetPayload() *blaze_models.Error {
	return o.Payload
}

func (o *GetMemberForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(blaze_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetMemberNotFound creates a GetMemberNotFound with default headers values
func NewGetMemberNotFound() *GetMemberNotFound {
	return &GetMemberNotFound{}
}

/*GetMemberNotFound handles this case with default header values.

Resource was not found
*/
type GetMemberNotFound struct {
	Payload *blaze_models.Error
}

func (o *GetMemberNotFound) Error() string {
	return fmt.Sprintf("[GET /partner/members/{memberId}][%d] getMemberNotFound  %+v", 404, o.Payload)
}

func (o *GetMemberNotFound) GetPayload() *blaze_models.Error {
	return o.Payload
}

func (o *GetMemberNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(blaze_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetMemberInternalServerError creates a GetMemberInternalServerError with default headers values
func NewGetMemberInternalServerError() *GetMemberInternalServerError {
	return &GetMemberInternalServerError{}
}

/*GetMemberInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetMemberInternalServerError struct {
	Payload *blaze_models.Error
}

func (o *GetMemberInternalServerError) Error() string {
	return fmt.Sprintf("[GET /partner/members/{memberId}][%d] getMemberInternalServerError  %+v", 500, o.Payload)
}

func (o *GetMemberInternalServerError) GetPayload() *blaze_models.Error {
	return o.Payload
}

func (o *GetMemberInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(blaze_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
