// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package companies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/crm/crm_models"
)

// PostCompaniesReader is a Reader for the PostCompanies structure.
type PostCompaniesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostCompaniesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostCompaniesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostCompaniesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostCompaniesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostCompaniesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostCompaniesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostCompaniesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostCompaniesOK creates a PostCompaniesOK with default headers values
func NewPostCompaniesOK() *PostCompaniesOK {
	return &PostCompaniesOK{}
}

/*PostCompaniesOK handles this case with default header values.

Taxnexus Response with Company objects
*/
type PostCompaniesOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *crm_models.CompanyResponse
}

func (o *PostCompaniesOK) Error() string {
	return fmt.Sprintf("[POST /companies][%d] postCompaniesOK  %+v", 200, o.Payload)
}

func (o *PostCompaniesOK) GetPayload() *crm_models.CompanyResponse {
	return o.Payload
}

func (o *PostCompaniesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(crm_models.CompanyResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCompaniesUnauthorized creates a PostCompaniesUnauthorized with default headers values
func NewPostCompaniesUnauthorized() *PostCompaniesUnauthorized {
	return &PostCompaniesUnauthorized{}
}

/*PostCompaniesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostCompaniesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PostCompaniesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /companies][%d] postCompaniesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostCompaniesUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostCompaniesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCompaniesForbidden creates a PostCompaniesForbidden with default headers values
func NewPostCompaniesForbidden() *PostCompaniesForbidden {
	return &PostCompaniesForbidden{}
}

/*PostCompaniesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostCompaniesForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PostCompaniesForbidden) Error() string {
	return fmt.Sprintf("[POST /companies][%d] postCompaniesForbidden  %+v", 403, o.Payload)
}

func (o *PostCompaniesForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostCompaniesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCompaniesNotFound creates a PostCompaniesNotFound with default headers values
func NewPostCompaniesNotFound() *PostCompaniesNotFound {
	return &PostCompaniesNotFound{}
}

/*PostCompaniesNotFound handles this case with default header values.

Resource was not found
*/
type PostCompaniesNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PostCompaniesNotFound) Error() string {
	return fmt.Sprintf("[POST /companies][%d] postCompaniesNotFound  %+v", 404, o.Payload)
}

func (o *PostCompaniesNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostCompaniesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCompaniesUnprocessableEntity creates a PostCompaniesUnprocessableEntity with default headers values
func NewPostCompaniesUnprocessableEntity() *PostCompaniesUnprocessableEntity {
	return &PostCompaniesUnprocessableEntity{}
}

/*PostCompaniesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostCompaniesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PostCompaniesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /companies][%d] postCompaniesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostCompaniesUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostCompaniesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostCompaniesInternalServerError creates a PostCompaniesInternalServerError with default headers values
func NewPostCompaniesInternalServerError() *PostCompaniesInternalServerError {
	return &PostCompaniesInternalServerError{}
}

/*PostCompaniesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostCompaniesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

func (o *PostCompaniesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /companies][%d] postCompaniesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostCompaniesInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *PostCompaniesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
