// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package database

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/devops/devops_models"
)

// PutDatabasesReader is a Reader for the PutDatabases structure.
type PutDatabasesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutDatabasesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutDatabasesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutDatabasesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutDatabasesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutDatabasesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutDatabasesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutDatabasesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutDatabasesOK creates a PutDatabasesOK with default headers values
func NewPutDatabasesOK() *PutDatabasesOK {
	return &PutDatabasesOK{}
}

/*PutDatabasesOK handles this case with default header values.

Taxnexus Response with Database objects
*/
type PutDatabasesOK struct {
	AccessControlAllowOrigin string

	Payload *devops_models.DatabaseResponse
}

func (o *PutDatabasesOK) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesOK  %+v", 200, o.Payload)
}

func (o *PutDatabasesOK) GetPayload() *devops_models.DatabaseResponse {
	return o.Payload
}

func (o *PutDatabasesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.DatabaseResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutDatabasesUnauthorized creates a PutDatabasesUnauthorized with default headers values
func NewPutDatabasesUnauthorized() *PutDatabasesUnauthorized {
	return &PutDatabasesUnauthorized{}
}

/*PutDatabasesUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PutDatabasesUnauthorized struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *PutDatabasesUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesUnauthorized  %+v", 401, o.Payload)
}

func (o *PutDatabasesUnauthorized) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutDatabasesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutDatabasesForbidden creates a PutDatabasesForbidden with default headers values
func NewPutDatabasesForbidden() *PutDatabasesForbidden {
	return &PutDatabasesForbidden{}
}

/*PutDatabasesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutDatabasesForbidden struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutDatabasesForbidden) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesForbidden  %+v", 403, o.Payload)
}

func (o *PutDatabasesForbidden) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutDatabasesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutDatabasesNotFound creates a PutDatabasesNotFound with default headers values
func NewPutDatabasesNotFound() *PutDatabasesNotFound {
	return &PutDatabasesNotFound{}
}

/*PutDatabasesNotFound handles this case with default header values.

Resource was not found
*/
type PutDatabasesNotFound struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutDatabasesNotFound) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesNotFound  %+v", 404, o.Payload)
}

func (o *PutDatabasesNotFound) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutDatabasesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutDatabasesUnprocessableEntity creates a PutDatabasesUnprocessableEntity with default headers values
func NewPutDatabasesUnprocessableEntity() *PutDatabasesUnprocessableEntity {
	return &PutDatabasesUnprocessableEntity{}
}

/*PutDatabasesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutDatabasesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *devops_models.Error
}

func (o *PutDatabasesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutDatabasesUnprocessableEntity) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutDatabasesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutDatabasesInternalServerError creates a PutDatabasesInternalServerError with default headers values
func NewPutDatabasesInternalServerError() *PutDatabasesInternalServerError {
	return &PutDatabasesInternalServerError{}
}

/*PutDatabasesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutDatabasesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *devops_models.Error
}

func (o *PutDatabasesInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /databases][%d] putDatabasesInternalServerError  %+v", 500, o.Payload)
}

func (o *PutDatabasesInternalServerError) GetPayload() *devops_models.Error {
	return o.Payload
}

func (o *PutDatabasesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(devops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
