// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package county

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetCountiesObservableParams creates a new GetCountiesObservableParams object
// with the default values initialized.
func NewGetCountiesObservableParams() *GetCountiesObservableParams {
	var ()
	return &GetCountiesObservableParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetCountiesObservableParamsWithTimeout creates a new GetCountiesObservableParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetCountiesObservableParamsWithTimeout(timeout time.Duration) *GetCountiesObservableParams {
	var ()
	return &GetCountiesObservableParams{

		timeout: timeout,
	}
}

// NewGetCountiesObservableParamsWithContext creates a new GetCountiesObservableParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetCountiesObservableParamsWithContext(ctx context.Context) *GetCountiesObservableParams {
	var ()
	return &GetCountiesObservableParams{

		Context: ctx,
	}
}

// NewGetCountiesObservableParamsWithHTTPClient creates a new GetCountiesObservableParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetCountiesObservableParamsWithHTTPClient(client *http.Client) *GetCountiesObservableParams {
	var ()
	return &GetCountiesObservableParams{
		HTTPClient: client,
	}
}

/*GetCountiesObservableParams contains all the parameters to send to the API endpoint
for the get counties observable operation typically these are written to a http.Request
*/
type GetCountiesObservableParams struct {

	/*County
	  The County Name

	*/
	County *string
	/*CountyID
	  The ID of this Object

	*/
	CountyID *string
	/*Geocode
	  The Geocode of this Place record

	*/
	Geocode *string
	/*State
	  The State or Province abbreviation (2 char)

	*/
	State *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get counties observable params
func (o *GetCountiesObservableParams) WithTimeout(timeout time.Duration) *GetCountiesObservableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get counties observable params
func (o *GetCountiesObservableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get counties observable params
func (o *GetCountiesObservableParams) WithContext(ctx context.Context) *GetCountiesObservableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get counties observable params
func (o *GetCountiesObservableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get counties observable params
func (o *GetCountiesObservableParams) WithHTTPClient(client *http.Client) *GetCountiesObservableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get counties observable params
func (o *GetCountiesObservableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCounty adds the county to the get counties observable params
func (o *GetCountiesObservableParams) WithCounty(county *string) *GetCountiesObservableParams {
	o.SetCounty(county)
	return o
}

// SetCounty adds the county to the get counties observable params
func (o *GetCountiesObservableParams) SetCounty(county *string) {
	o.County = county
}

// WithCountyID adds the countyID to the get counties observable params
func (o *GetCountiesObservableParams) WithCountyID(countyID *string) *GetCountiesObservableParams {
	o.SetCountyID(countyID)
	return o
}

// SetCountyID adds the countyId to the get counties observable params
func (o *GetCountiesObservableParams) SetCountyID(countyID *string) {
	o.CountyID = countyID
}

// WithGeocode adds the geocode to the get counties observable params
func (o *GetCountiesObservableParams) WithGeocode(geocode *string) *GetCountiesObservableParams {
	o.SetGeocode(geocode)
	return o
}

// SetGeocode adds the geocode to the get counties observable params
func (o *GetCountiesObservableParams) SetGeocode(geocode *string) {
	o.Geocode = geocode
}

// WithState adds the state to the get counties observable params
func (o *GetCountiesObservableParams) WithState(state *string) *GetCountiesObservableParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the get counties observable params
func (o *GetCountiesObservableParams) SetState(state *string) {
	o.State = state
}

// WriteToRequest writes these params to a swagger request
func (o *GetCountiesObservableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.County != nil {

		// query param county
		var qrCounty string
		if o.County != nil {
			qrCounty = *o.County
		}
		qCounty := qrCounty
		if qCounty != "" {
			if err := r.SetQueryParam("county", qCounty); err != nil {
				return err
			}
		}

	}

	if o.CountyID != nil {

		// query param countyId
		var qrCountyID string
		if o.CountyID != nil {
			qrCountyID = *o.CountyID
		}
		qCountyID := qrCountyID
		if qCountyID != "" {
			if err := r.SetQueryParam("countyId", qCountyID); err != nil {
				return err
			}
		}

	}

	if o.Geocode != nil {

		// query param geocode
		var qrGeocode string
		if o.Geocode != nil {
			qrGeocode = *o.Geocode
		}
		qGeocode := qrGeocode
		if qGeocode != "" {
			if err := r.SetQueryParam("geocode", qGeocode); err != nil {
				return err
			}
		}

	}

	if o.State != nil {

		// query param state
		var qrState string
		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {
			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
