// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package county

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/geo/geo_models"
)

// GetCountiesObservableReader is a Reader for the GetCountiesObservable structure.
type GetCountiesObservableReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCountiesObservableReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCountiesObservableOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetCountiesObservableUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetCountiesObservableForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetCountiesObservableNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetCountiesObservableUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetCountiesObservableInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetCountiesObservableOK creates a GetCountiesObservableOK with default headers values
func NewGetCountiesObservableOK() *GetCountiesObservableOK {
	return &GetCountiesObservableOK{}
}

/*GetCountiesObservableOK handles this case with default header values.

Observable array response to a county retrieval
*/
type GetCountiesObservableOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload []*geo_models.County
}

func (o *GetCountiesObservableOK) Error() string {
	return fmt.Sprintf("[GET /counties/observable][%d] getCountiesObservableOK  %+v", 200, o.Payload)
}

func (o *GetCountiesObservableOK) GetPayload() []*geo_models.County {
	return o.Payload
}

func (o *GetCountiesObservableOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCountiesObservableUnauthorized creates a GetCountiesObservableUnauthorized with default headers values
func NewGetCountiesObservableUnauthorized() *GetCountiesObservableUnauthorized {
	return &GetCountiesObservableUnauthorized{}
}

/*GetCountiesObservableUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetCountiesObservableUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *geo_models.Error
}

func (o *GetCountiesObservableUnauthorized) Error() string {
	return fmt.Sprintf("[GET /counties/observable][%d] getCountiesObservableUnauthorized  %+v", 401, o.Payload)
}

func (o *GetCountiesObservableUnauthorized) GetPayload() *geo_models.Error {
	return o.Payload
}

func (o *GetCountiesObservableUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(geo_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCountiesObservableForbidden creates a GetCountiesObservableForbidden with default headers values
func NewGetCountiesObservableForbidden() *GetCountiesObservableForbidden {
	return &GetCountiesObservableForbidden{}
}

/*GetCountiesObservableForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetCountiesObservableForbidden struct {
	AccessControlAllowOrigin string

	Payload *geo_models.Error
}

func (o *GetCountiesObservableForbidden) Error() string {
	return fmt.Sprintf("[GET /counties/observable][%d] getCountiesObservableForbidden  %+v", 403, o.Payload)
}

func (o *GetCountiesObservableForbidden) GetPayload() *geo_models.Error {
	return o.Payload
}

func (o *GetCountiesObservableForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(geo_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCountiesObservableNotFound creates a GetCountiesObservableNotFound with default headers values
func NewGetCountiesObservableNotFound() *GetCountiesObservableNotFound {
	return &GetCountiesObservableNotFound{}
}

/*GetCountiesObservableNotFound handles this case with default header values.

Resource was not found
*/
type GetCountiesObservableNotFound struct {
	AccessControlAllowOrigin string

	Payload *geo_models.Error
}

func (o *GetCountiesObservableNotFound) Error() string {
	return fmt.Sprintf("[GET /counties/observable][%d] getCountiesObservableNotFound  %+v", 404, o.Payload)
}

func (o *GetCountiesObservableNotFound) GetPayload() *geo_models.Error {
	return o.Payload
}

func (o *GetCountiesObservableNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(geo_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCountiesObservableUnprocessableEntity creates a GetCountiesObservableUnprocessableEntity with default headers values
func NewGetCountiesObservableUnprocessableEntity() *GetCountiesObservableUnprocessableEntity {
	return &GetCountiesObservableUnprocessableEntity{}
}

/*GetCountiesObservableUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetCountiesObservableUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *geo_models.Error
}

func (o *GetCountiesObservableUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /counties/observable][%d] getCountiesObservableUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetCountiesObservableUnprocessableEntity) GetPayload() *geo_models.Error {
	return o.Payload
}

func (o *GetCountiesObservableUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(geo_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCountiesObservableInternalServerError creates a GetCountiesObservableInternalServerError with default headers values
func NewGetCountiesObservableInternalServerError() *GetCountiesObservableInternalServerError {
	return &GetCountiesObservableInternalServerError{}
}

/*GetCountiesObservableInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetCountiesObservableInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *geo_models.Error
}

func (o *GetCountiesObservableInternalServerError) Error() string {
	return fmt.Sprintf("[GET /counties/observable][%d] getCountiesObservableInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCountiesObservableInternalServerError) GetPayload() *geo_models.Error {
	return o.Payload
}

func (o *GetCountiesObservableInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(geo_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
