// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package place

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetPlacesParams creates a new GetPlacesParams object
// with the default values initialized.
func NewGetPlacesParams() *GetPlacesParams {
	var ()
	return &GetPlacesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetPlacesParamsWithTimeout creates a new GetPlacesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetPlacesParamsWithTimeout(timeout time.Duration) *GetPlacesParams {
	var ()
	return &GetPlacesParams{

		timeout: timeout,
	}
}

// NewGetPlacesParamsWithContext creates a new GetPlacesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetPlacesParamsWithContext(ctx context.Context) *GetPlacesParams {
	var ()
	return &GetPlacesParams{

		Context: ctx,
	}
}

// NewGetPlacesParamsWithHTTPClient creates a new GetPlacesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetPlacesParamsWithHTTPClient(client *http.Client) *GetPlacesParams {
	var ()
	return &GetPlacesParams{
		HTTPClient: client,
	}
}

/*GetPlacesParams contains all the parameters to send to the API endpoint
for the get places operation typically these are written to a http.Request
*/
type GetPlacesParams struct {

	/*Geocode
	  The Geocode of this Place record

	*/
	Geocode *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*PlaceID
	  The ID of a Place record

	*/
	PlaceID *string
	/*State
	  The State or Province abbreviation (2 char)

	*/
	State *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get places params
func (o *GetPlacesParams) WithTimeout(timeout time.Duration) *GetPlacesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get places params
func (o *GetPlacesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get places params
func (o *GetPlacesParams) WithContext(ctx context.Context) *GetPlacesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get places params
func (o *GetPlacesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get places params
func (o *GetPlacesParams) WithHTTPClient(client *http.Client) *GetPlacesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get places params
func (o *GetPlacesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithGeocode adds the geocode to the get places params
func (o *GetPlacesParams) WithGeocode(geocode *string) *GetPlacesParams {
	o.SetGeocode(geocode)
	return o
}

// SetGeocode adds the geocode to the get places params
func (o *GetPlacesParams) SetGeocode(geocode *string) {
	o.Geocode = geocode
}

// WithLimit adds the limit to the get places params
func (o *GetPlacesParams) WithLimit(limit *int64) *GetPlacesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get places params
func (o *GetPlacesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get places params
func (o *GetPlacesParams) WithOffset(offset *int64) *GetPlacesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get places params
func (o *GetPlacesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPlaceID adds the placeID to the get places params
func (o *GetPlacesParams) WithPlaceID(placeID *string) *GetPlacesParams {
	o.SetPlaceID(placeID)
	return o
}

// SetPlaceID adds the placeId to the get places params
func (o *GetPlacesParams) SetPlaceID(placeID *string) {
	o.PlaceID = placeID
}

// WithState adds the state to the get places params
func (o *GetPlacesParams) WithState(state *string) *GetPlacesParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the get places params
func (o *GetPlacesParams) SetState(state *string) {
	o.State = state
}

// WriteToRequest writes these params to a swagger request
func (o *GetPlacesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Geocode != nil {

		// query param geocode
		var qrGeocode string
		if o.Geocode != nil {
			qrGeocode = *o.Geocode
		}
		qGeocode := qrGeocode
		if qGeocode != "" {
			if err := r.SetQueryParam("geocode", qGeocode); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.PlaceID != nil {

		// query param placeId
		var qrPlaceID string
		if o.PlaceID != nil {
			qrPlaceID = *o.PlaceID
		}
		qPlaceID := qrPlaceID
		if qPlaceID != "" {
			if err := r.SetQueryParam("placeId", qPlaceID); err != nil {
				return err
			}
		}

	}

	if o.State != nil {

		// query param state
		var qrState string
		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {
			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
