// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tax_rate

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new tax rate API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for tax rate API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetTaxRateObservable(params *GetTaxRateObservableParams, authInfo runtime.ClientAuthInfoWriter) (*GetTaxRateObservableOK, error)

	GetTaxRates(params *GetTaxRatesParams, authInfo runtime.ClientAuthInfoWriter) (*GetTaxRatesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetTaxRateObservable gets taxrates in an observable array

  Returns a taxrate retrieval in a observable array
*/
func (a *Client) GetTaxRateObservable(params *GetTaxRateObservableParams, authInfo runtime.ClientAuthInfoWriter) (*GetTaxRateObservableOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTaxRateObservableParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getTaxRateObservable",
		Method:             "GET",
		PathPattern:        "/taxrates/observable",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTaxRateObservableReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTaxRateObservableOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTaxRateObservable: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetTaxRates combineds tax rates

  Returns SALES TAX rates based on County or Place ID
*/
func (a *Client) GetTaxRates(params *GetTaxRatesParams, authInfo runtime.ClientAuthInfoWriter) (*GetTaxRatesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTaxRatesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getTaxRates",
		Method:             "GET",
		PathPattern:        "/taxrates",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTaxRatesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTaxRatesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTaxRates: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
