// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package coa

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new coa API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for coa API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetCoas(params *GetCoasParams, authInfo runtime.ClientAuthInfoWriter) (*GetCoasOK, error)

	PostCoas(params *PostCoasParams, authInfo runtime.ClientAuthInfoWriter) (*PostCoasOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetCoas gets chart of accounts reports
*/
func (a *Client) GetCoas(params *GetCoasParams, authInfo runtime.ClientAuthInfoWriter) (*GetCoasOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetCoasParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getCoas",
		Method:             "GET",
		PathPattern:        "/coas",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetCoasReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetCoasOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getCoas: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostCoas creates new accounting report
*/
func (a *Client) PostCoas(params *PostCoasParams, authInfo runtime.ClientAuthInfoWriter) (*PostCoasOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostCoasParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postCoas",
		Method:             "POST",
		PathPattern:        "/coas",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostCoasReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostCoasOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postCoas: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
