// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package items

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// PostItemsReader is a Reader for the PostItems structure.
type PostItemsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostItemsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostItemsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostItemsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostItemsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostItemsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostItemsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostItemsOK creates a PostItemsOK with default headers values
func NewPostItemsOK() *PostItemsOK {
	return &PostItemsOK{}
}

/*PostItemsOK handles this case with default header values.

An array of Items records with the new IDs
*/
type PostItemsOK struct {
	Payload *metrc_gw_models.ItemResponse
}

func (o *PostItemsOK) Error() string {
	return fmt.Sprintf("[POST /items][%d] postItemsOK  %+v", 200, o.Payload)
}

func (o *PostItemsOK) GetPayload() *metrc_gw_models.ItemResponse {
	return o.Payload
}

func (o *PostItemsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.ItemResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostItemsUnauthorized creates a PostItemsUnauthorized with default headers values
func NewPostItemsUnauthorized() *PostItemsUnauthorized {
	return &PostItemsUnauthorized{}
}

/*PostItemsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostItemsUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *PostItemsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /items][%d] postItemsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostItemsUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostItemsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostItemsForbidden creates a PostItemsForbidden with default headers values
func NewPostItemsForbidden() *PostItemsForbidden {
	return &PostItemsForbidden{}
}

/*PostItemsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostItemsForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *PostItemsForbidden) Error() string {
	return fmt.Sprintf("[POST /items][%d] postItemsForbidden  %+v", 403, o.Payload)
}

func (o *PostItemsForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostItemsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostItemsNotFound creates a PostItemsNotFound with default headers values
func NewPostItemsNotFound() *PostItemsNotFound {
	return &PostItemsNotFound{}
}

/*PostItemsNotFound handles this case with default header values.

Resource was not found
*/
type PostItemsNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *PostItemsNotFound) Error() string {
	return fmt.Sprintf("[POST /items][%d] postItemsNotFound  %+v", 404, o.Payload)
}

func (o *PostItemsNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostItemsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostItemsInternalServerError creates a PostItemsInternalServerError with default headers values
func NewPostItemsInternalServerError() *PostItemsInternalServerError {
	return &PostItemsInternalServerError{}
}

/*PostItemsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostItemsInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *PostItemsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /items][%d] postItemsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostItemsInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostItemsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
