// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package packages

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new packages API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for packages API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetPackageAdjustmentReasons(params *GetPackageAdjustmentReasonsParams, authInfo runtime.ClientAuthInfoWriter) (*GetPackageAdjustmentReasonsOK, error)

	GetPackageTypes(params *GetPackageTypesParams, authInfo runtime.ClientAuthInfoWriter) (*GetPackageTypesOK, error)

	GetPackages(params *GetPackagesParams, authInfo runtime.ClientAuthInfoWriter) (*GetPackagesOK, error)

	PostPackages(params *PostPackagesParams, authInfo runtime.ClientAuthInfoWriter) (*PostPackagesOK, error)

	PutPackages(params *PutPackagesParams, authInfo runtime.ClientAuthInfoWriter) (*PutPackagesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetPackageAdjustmentReasons packages types

  Get Package Types

*/
func (a *Client) GetPackageAdjustmentReasons(params *GetPackageAdjustmentReasonsParams, authInfo runtime.ClientAuthInfoWriter) (*GetPackageAdjustmentReasonsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetPackageAdjustmentReasonsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getPackageAdjustmentReasons",
		Method:             "GET",
		PathPattern:        "/packages/adjustmentreasons",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetPackageAdjustmentReasonsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetPackageAdjustmentReasonsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getPackageAdjustmentReasons: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetPackageTypes packages types

  Get Package Types

*/
func (a *Client) GetPackageTypes(params *GetPackageTypesParams, authInfo runtime.ClientAuthInfoWriter) (*GetPackageTypesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetPackageTypesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getPackageTypes",
		Method:             "GET",
		PathPattern:        "/packages/types",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetPackageTypesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetPackageTypesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getPackageTypes: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetPackages gets packages

  Get a single Item for this User-License

*/
func (a *Client) GetPackages(params *GetPackagesParams, authInfo runtime.ClientAuthInfoWriter) (*GetPackagesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetPackagesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getPackages",
		Method:             "GET",
		PathPattern:        "/packages",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetPackagesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetPackagesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getPackages: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostPackages creates new packages

  Create new Packages
*/
func (a *Client) PostPackages(params *PostPackagesParams, authInfo runtime.ClientAuthInfoWriter) (*PostPackagesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostPackagesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postPackages",
		Method:             "POST",
		PathPattern:        "/packages",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostPackagesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostPackagesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postPackages: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutPackages updates existing packages

  Update existing Packages
*/
func (a *Client) PutPackages(params *PutPackagesParams, authInfo runtime.ClientAuthInfoWriter) (*PutPackagesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutPackagesParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putPackages",
		Method:             "PUT",
		PathPattern:        "/packages",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutPackagesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutPackagesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putPackages: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
