// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package packages

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// PostPackagesReader is a Reader for the PostPackages structure.
type PostPackagesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostPackagesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostPackagesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostPackagesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostPackagesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostPackagesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostPackagesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostPackagesOK creates a PostPackagesOK with default headers values
func NewPostPackagesOK() *PostPackagesOK {
	return &PostPackagesOK{}
}

/*PostPackagesOK handles this case with default header values.

An array of Items records with the new IDs
*/
type PostPackagesOK struct {
	Payload *metrc_gw_models.PackageResponse
}

func (o *PostPackagesOK) Error() string {
	return fmt.Sprintf("[POST /packages][%d] postPackagesOK  %+v", 200, o.Payload)
}

func (o *PostPackagesOK) GetPayload() *metrc_gw_models.PackageResponse {
	return o.Payload
}

func (o *PostPackagesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.PackageResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPackagesUnauthorized creates a PostPackagesUnauthorized with default headers values
func NewPostPackagesUnauthorized() *PostPackagesUnauthorized {
	return &PostPackagesUnauthorized{}
}

/*PostPackagesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostPackagesUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *PostPackagesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /packages][%d] postPackagesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostPackagesUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostPackagesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPackagesForbidden creates a PostPackagesForbidden with default headers values
func NewPostPackagesForbidden() *PostPackagesForbidden {
	return &PostPackagesForbidden{}
}

/*PostPackagesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostPackagesForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *PostPackagesForbidden) Error() string {
	return fmt.Sprintf("[POST /packages][%d] postPackagesForbidden  %+v", 403, o.Payload)
}

func (o *PostPackagesForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostPackagesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPackagesNotFound creates a PostPackagesNotFound with default headers values
func NewPostPackagesNotFound() *PostPackagesNotFound {
	return &PostPackagesNotFound{}
}

/*PostPackagesNotFound handles this case with default header values.

Resource was not found
*/
type PostPackagesNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *PostPackagesNotFound) Error() string {
	return fmt.Sprintf("[POST /packages][%d] postPackagesNotFound  %+v", 404, o.Payload)
}

func (o *PostPackagesNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostPackagesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostPackagesInternalServerError creates a PostPackagesInternalServerError with default headers values
func NewPostPackagesInternalServerError() *PostPackagesInternalServerError {
	return &PostPackagesInternalServerError{}
}

/*PostPackagesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostPackagesInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *PostPackagesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /packages][%d] postPackagesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostPackagesInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *PostPackagesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
