// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package plants

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/metrc-gw/metrc_gw_models"
)

// DeletePlantReader is a Reader for the DeletePlant structure.
type DeletePlantReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeletePlantReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeletePlantOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeletePlantUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeletePlantForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeletePlantNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeletePlantInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewDeletePlantOK creates a DeletePlantOK with default headers values
func NewDeletePlantOK() *DeletePlantOK {
	return &DeletePlantOK{}
}

/*DeletePlantOK handles this case with default header values.

Plants were successfully Deleted
*/
type DeletePlantOK struct {
	Payload *metrc_gw_models.PlantResponse
}

func (o *DeletePlantOK) Error() string {
	return fmt.Sprintf("[DELETE /plants][%d] deletePlantOK  %+v", 200, o.Payload)
}

func (o *DeletePlantOK) GetPayload() *metrc_gw_models.PlantResponse {
	return o.Payload
}

func (o *DeletePlantOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.PlantResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeletePlantUnauthorized creates a DeletePlantUnauthorized with default headers values
func NewDeletePlantUnauthorized() *DeletePlantUnauthorized {
	return &DeletePlantUnauthorized{}
}

/*DeletePlantUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type DeletePlantUnauthorized struct {
	Payload *metrc_gw_models.Error
}

func (o *DeletePlantUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /plants][%d] deletePlantUnauthorized  %+v", 401, o.Payload)
}

func (o *DeletePlantUnauthorized) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeletePlantUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeletePlantForbidden creates a DeletePlantForbidden with default headers values
func NewDeletePlantForbidden() *DeletePlantForbidden {
	return &DeletePlantForbidden{}
}

/*DeletePlantForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type DeletePlantForbidden struct {
	Payload *metrc_gw_models.Error
}

func (o *DeletePlantForbidden) Error() string {
	return fmt.Sprintf("[DELETE /plants][%d] deletePlantForbidden  %+v", 403, o.Payload)
}

func (o *DeletePlantForbidden) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeletePlantForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeletePlantNotFound creates a DeletePlantNotFound with default headers values
func NewDeletePlantNotFound() *DeletePlantNotFound {
	return &DeletePlantNotFound{}
}

/*DeletePlantNotFound handles this case with default header values.

Resource was not found
*/
type DeletePlantNotFound struct {
	Payload *metrc_gw_models.Error
}

func (o *DeletePlantNotFound) Error() string {
	return fmt.Sprintf("[DELETE /plants][%d] deletePlantNotFound  %+v", 404, o.Payload)
}

func (o *DeletePlantNotFound) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeletePlantNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeletePlantInternalServerError creates a DeletePlantInternalServerError with default headers values
func NewDeletePlantInternalServerError() *DeletePlantInternalServerError {
	return &DeletePlantInternalServerError{}
}

/*DeletePlantInternalServerError handles this case with default header values.

Server Internal Error
*/
type DeletePlantInternalServerError struct {
	Payload *metrc_gw_models.Error
}

func (o *DeletePlantInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /plants][%d] deletePlantInternalServerError  %+v", 500, o.Payload)
}

func (o *DeletePlantInternalServerError) GetPayload() *metrc_gw_models.Error {
	return o.Payload
}

func (o *DeletePlantInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(metrc_gw_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
