// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package rooms

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteRoomParams creates a new DeleteRoomParams object
// with the default values initialized.
func NewDeleteRoomParams() *DeleteRoomParams {
	var ()
	return &DeleteRoomParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteRoomParamsWithTimeout creates a new DeleteRoomParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewDeleteRoomParamsWithTimeout(timeout time.Duration) *DeleteRoomParams {
	var ()
	return &DeleteRoomParams{

		timeout: timeout,
	}
}

// NewDeleteRoomParamsWithContext creates a new DeleteRoomParams object
// with the default values initialized, and the ability to set a context for a request
func NewDeleteRoomParamsWithContext(ctx context.Context) *DeleteRoomParams {
	var ()
	return &DeleteRoomParams{

		Context: ctx,
	}
}

// NewDeleteRoomParamsWithHTTPClient creates a new DeleteRoomParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewDeleteRoomParamsWithHTTPClient(client *http.Client) *DeleteRoomParams {
	var ()
	return &DeleteRoomParams{
		HTTPClient: client,
	}
}

/*DeleteRoomParams contains all the parameters to send to the API endpoint
for the delete room operation typically these are written to a http.Request
*/
type DeleteRoomParams struct {

	/*License
	  The Licnese Number for the query

	*/
	License string
	/*Reseller
	  The METRC Reseller Key

	*/
	Reseller string
	/*RoomNumber
	  The Room ID number

	*/
	RoomNumber string
	/*State
	  The 2-character State Code

	*/
	State string
	/*User
	  The METRC User Key

	*/
	User string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the delete room params
func (o *DeleteRoomParams) WithTimeout(timeout time.Duration) *DeleteRoomParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete room params
func (o *DeleteRoomParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete room params
func (o *DeleteRoomParams) WithContext(ctx context.Context) *DeleteRoomParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete room params
func (o *DeleteRoomParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete room params
func (o *DeleteRoomParams) WithHTTPClient(client *http.Client) *DeleteRoomParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete room params
func (o *DeleteRoomParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLicense adds the license to the delete room params
func (o *DeleteRoomParams) WithLicense(license string) *DeleteRoomParams {
	o.SetLicense(license)
	return o
}

// SetLicense adds the license to the delete room params
func (o *DeleteRoomParams) SetLicense(license string) {
	o.License = license
}

// WithReseller adds the reseller to the delete room params
func (o *DeleteRoomParams) WithReseller(reseller string) *DeleteRoomParams {
	o.SetReseller(reseller)
	return o
}

// SetReseller adds the reseller to the delete room params
func (o *DeleteRoomParams) SetReseller(reseller string) {
	o.Reseller = reseller
}

// WithRoomNumber adds the roomNumber to the delete room params
func (o *DeleteRoomParams) WithRoomNumber(roomNumber string) *DeleteRoomParams {
	o.SetRoomNumber(roomNumber)
	return o
}

// SetRoomNumber adds the roomNumber to the delete room params
func (o *DeleteRoomParams) SetRoomNumber(roomNumber string) {
	o.RoomNumber = roomNumber
}

// WithState adds the state to the delete room params
func (o *DeleteRoomParams) WithState(state string) *DeleteRoomParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the delete room params
func (o *DeleteRoomParams) SetState(state string) {
	o.State = state
}

// WithUser adds the user to the delete room params
func (o *DeleteRoomParams) WithUser(user string) *DeleteRoomParams {
	o.SetUser(user)
	return o
}

// SetUser adds the user to the delete room params
func (o *DeleteRoomParams) SetUser(user string) {
	o.User = user
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteRoomParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// query param license
	qrLicense := o.License
	qLicense := qrLicense
	if qLicense != "" {
		if err := r.SetQueryParam("license", qLicense); err != nil {
			return err
		}
	}

	// query param reseller
	qrReseller := o.Reseller
	qReseller := qrReseller
	if qReseller != "" {
		if err := r.SetQueryParam("reseller", qReseller); err != nil {
			return err
		}
	}

	// query param roomNumber
	qrRoomNumber := o.RoomNumber
	qRoomNumber := qrRoomNumber
	if qRoomNumber != "" {
		if err := r.SetQueryParam("roomNumber", qRoomNumber); err != nil {
			return err
		}
	}

	// query param state
	qrState := o.State
	qState := qrState
	if qState != "" {
		if err := r.SetQueryParam("state", qState); err != nil {
			return err
		}
	}

	// query param user
	qrUser := o.User
	qUser := qrUser
	if qUser != "" {
		if err := r.SetQueryParam("user", qUser); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
