// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package charge

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// GetChargesReader is a Reader for the GetCharges structure.
type GetChargesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetChargesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetChargesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetChargesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetChargesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetChargesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetChargesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetChargesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetChargesOK creates a GetChargesOK with default headers values
func NewGetChargesOK() *GetChargesOK {
	return &GetChargesOK{}
}

/*GetChargesOK handles this case with default header values.

Taxnexus Response with Charge objects
*/
type GetChargesOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *ops_models.ChargeResponse
}

func (o *GetChargesOK) Error() string {
	return fmt.Sprintf("[GET /charges][%d] getChargesOK  %+v", 200, o.Payload)
}

func (o *GetChargesOK) GetPayload() *ops_models.ChargeResponse {
	return o.Payload
}

func (o *GetChargesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(ops_models.ChargeResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetChargesUnauthorized creates a GetChargesUnauthorized with default headers values
func NewGetChargesUnauthorized() *GetChargesUnauthorized {
	return &GetChargesUnauthorized{}
}

/*GetChargesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type GetChargesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *GetChargesUnauthorized) Error() string {
	return fmt.Sprintf("[GET /charges][%d] getChargesUnauthorized  %+v", 401, o.Payload)
}

func (o *GetChargesUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *GetChargesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetChargesForbidden creates a GetChargesForbidden with default headers values
func NewGetChargesForbidden() *GetChargesForbidden {
	return &GetChargesForbidden{}
}

/*GetChargesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetChargesForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *GetChargesForbidden) Error() string {
	return fmt.Sprintf("[GET /charges][%d] getChargesForbidden  %+v", 403, o.Payload)
}

func (o *GetChargesForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *GetChargesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetChargesNotFound creates a GetChargesNotFound with default headers values
func NewGetChargesNotFound() *GetChargesNotFound {
	return &GetChargesNotFound{}
}

/*GetChargesNotFound handles this case with default header values.

Resource was not found
*/
type GetChargesNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *GetChargesNotFound) Error() string {
	return fmt.Sprintf("[GET /charges][%d] getChargesNotFound  %+v", 404, o.Payload)
}

func (o *GetChargesNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *GetChargesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetChargesUnprocessableEntity creates a GetChargesUnprocessableEntity with default headers values
func NewGetChargesUnprocessableEntity() *GetChargesUnprocessableEntity {
	return &GetChargesUnprocessableEntity{}
}

/*GetChargesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetChargesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *GetChargesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /charges][%d] getChargesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetChargesUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *GetChargesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetChargesInternalServerError creates a GetChargesInternalServerError with default headers values
func NewGetChargesInternalServerError() *GetChargesInternalServerError {
	return &GetChargesInternalServerError{}
}

/*GetChargesInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetChargesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *GetChargesInternalServerError) Error() string {
	return fmt.Sprintf("[GET /charges][%d] getChargesInternalServerError  %+v", 500, o.Payload)
}

func (o *GetChargesInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *GetChargesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
