// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package charge

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// PostChargesReader is a Reader for the PostCharges structure.
type PostChargesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostChargesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostChargesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostChargesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostChargesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostChargesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostChargesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostChargesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostChargesOK creates a PostChargesOK with default headers values
func NewPostChargesOK() *PostChargesOK {
	return &PostChargesOK{}
}

/*PostChargesOK handles this case with default header values.

Taxnexus Response with Charge objects
*/
type PostChargesOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *ops_models.ChargeResponse
}

func (o *PostChargesOK) Error() string {
	return fmt.Sprintf("[POST /charges][%d] postChargesOK  %+v", 200, o.Payload)
}

func (o *PostChargesOK) GetPayload() *ops_models.ChargeResponse {
	return o.Payload
}

func (o *PostChargesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(ops_models.ChargeResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostChargesUnauthorized creates a PostChargesUnauthorized with default headers values
func NewPostChargesUnauthorized() *PostChargesUnauthorized {
	return &PostChargesUnauthorized{}
}

/*PostChargesUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostChargesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostChargesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /charges][%d] postChargesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostChargesUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostChargesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostChargesForbidden creates a PostChargesForbidden with default headers values
func NewPostChargesForbidden() *PostChargesForbidden {
	return &PostChargesForbidden{}
}

/*PostChargesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostChargesForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostChargesForbidden) Error() string {
	return fmt.Sprintf("[POST /charges][%d] postChargesForbidden  %+v", 403, o.Payload)
}

func (o *PostChargesForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostChargesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostChargesNotFound creates a PostChargesNotFound with default headers values
func NewPostChargesNotFound() *PostChargesNotFound {
	return &PostChargesNotFound{}
}

/*PostChargesNotFound handles this case with default header values.

Resource was not found
*/
type PostChargesNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostChargesNotFound) Error() string {
	return fmt.Sprintf("[POST /charges][%d] postChargesNotFound  %+v", 404, o.Payload)
}

func (o *PostChargesNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostChargesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostChargesUnprocessableEntity creates a PostChargesUnprocessableEntity with default headers values
func NewPostChargesUnprocessableEntity() *PostChargesUnprocessableEntity {
	return &PostChargesUnprocessableEntity{}
}

/*PostChargesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostChargesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostChargesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /charges][%d] postChargesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostChargesUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostChargesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostChargesInternalServerError creates a PostChargesInternalServerError with default headers values
func NewPostChargesInternalServerError() *PostChargesInternalServerError {
	return &PostChargesInternalServerError{}
}

/*PostChargesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostChargesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostChargesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /charges][%d] postChargesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostChargesInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostChargesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
