// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package eft

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// PostEftsReader is a Reader for the PostEfts structure.
type PostEftsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostEftsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostEftsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostEftsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostEftsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostEftsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostEftsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostEftsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostEftsOK creates a PostEftsOK with default headers values
func NewPostEftsOK() *PostEftsOK {
	return &PostEftsOK{}
}

/*PostEftsOK handles this case with default header values.

Taxnexus Response with EFT objects
*/
type PostEftsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *ops_models.EftResponse
}

func (o *PostEftsOK) Error() string {
	return fmt.Sprintf("[POST /efts][%d] postEftsOK  %+v", 200, o.Payload)
}

func (o *PostEftsOK) GetPayload() *ops_models.EftResponse {
	return o.Payload
}

func (o *PostEftsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(ops_models.EftResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostEftsUnauthorized creates a PostEftsUnauthorized with default headers values
func NewPostEftsUnauthorized() *PostEftsUnauthorized {
	return &PostEftsUnauthorized{}
}

/*PostEftsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostEftsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostEftsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /efts][%d] postEftsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostEftsUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostEftsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostEftsForbidden creates a PostEftsForbidden with default headers values
func NewPostEftsForbidden() *PostEftsForbidden {
	return &PostEftsForbidden{}
}

/*PostEftsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostEftsForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostEftsForbidden) Error() string {
	return fmt.Sprintf("[POST /efts][%d] postEftsForbidden  %+v", 403, o.Payload)
}

func (o *PostEftsForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostEftsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostEftsNotFound creates a PostEftsNotFound with default headers values
func NewPostEftsNotFound() *PostEftsNotFound {
	return &PostEftsNotFound{}
}

/*PostEftsNotFound handles this case with default header values.

Resource was not found
*/
type PostEftsNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostEftsNotFound) Error() string {
	return fmt.Sprintf("[POST /efts][%d] postEftsNotFound  %+v", 404, o.Payload)
}

func (o *PostEftsNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostEftsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostEftsUnprocessableEntity creates a PostEftsUnprocessableEntity with default headers values
func NewPostEftsUnprocessableEntity() *PostEftsUnprocessableEntity {
	return &PostEftsUnprocessableEntity{}
}

/*PostEftsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostEftsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostEftsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /efts][%d] postEftsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostEftsUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostEftsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostEftsInternalServerError creates a PostEftsInternalServerError with default headers values
func NewPostEftsInternalServerError() *PostEftsInternalServerError {
	return &PostEftsInternalServerError{}
}

/*PostEftsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostEftsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PostEftsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /efts][%d] postEftsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostEftsInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PostEftsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
