// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package eft

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/ops/ops_models"
)

// PutEftsReader is a Reader for the PutEfts structure.
type PutEftsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutEftsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutEftsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutEftsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutEftsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutEftsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutEftsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutEftsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutEftsOK creates a PutEftsOK with default headers values
func NewPutEftsOK() *PutEftsOK {
	return &PutEftsOK{}
}

/*PutEftsOK handles this case with default header values.

Taxnexus Response with an array of Message objects in response to a PUT
*/
type PutEftsOK struct {
	AccessControlAllowOrigin string

	Payload *ops_models.PutResponse
}

func (o *PutEftsOK) Error() string {
	return fmt.Sprintf("[PUT /efts][%d] putEftsOK  %+v", 200, o.Payload)
}

func (o *PutEftsOK) GetPayload() *ops_models.PutResponse {
	return o.Payload
}

func (o *PutEftsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.PutResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutEftsUnauthorized creates a PutEftsUnauthorized with default headers values
func NewPutEftsUnauthorized() *PutEftsUnauthorized {
	return &PutEftsUnauthorized{}
}

/*PutEftsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutEftsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutEftsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /efts][%d] putEftsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutEftsUnauthorized) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutEftsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutEftsForbidden creates a PutEftsForbidden with default headers values
func NewPutEftsForbidden() *PutEftsForbidden {
	return &PutEftsForbidden{}
}

/*PutEftsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutEftsForbidden struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutEftsForbidden) Error() string {
	return fmt.Sprintf("[PUT /efts][%d] putEftsForbidden  %+v", 403, o.Payload)
}

func (o *PutEftsForbidden) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutEftsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutEftsNotFound creates a PutEftsNotFound with default headers values
func NewPutEftsNotFound() *PutEftsNotFound {
	return &PutEftsNotFound{}
}

/*PutEftsNotFound handles this case with default header values.

Resource was not found
*/
type PutEftsNotFound struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutEftsNotFound) Error() string {
	return fmt.Sprintf("[PUT /efts][%d] putEftsNotFound  %+v", 404, o.Payload)
}

func (o *PutEftsNotFound) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutEftsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutEftsUnprocessableEntity creates a PutEftsUnprocessableEntity with default headers values
func NewPutEftsUnprocessableEntity() *PutEftsUnprocessableEntity {
	return &PutEftsUnprocessableEntity{}
}

/*PutEftsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutEftsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutEftsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /efts][%d] putEftsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutEftsUnprocessableEntity) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutEftsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutEftsInternalServerError creates a PutEftsInternalServerError with default headers values
func NewPutEftsInternalServerError() *PutEftsInternalServerError {
	return &PutEftsInternalServerError{}
}

/*PutEftsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutEftsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *ops_models.Error
}

func (o *PutEftsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /efts][%d] putEftsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutEftsInternalServerError) GetPayload() *ops_models.Error {
	return o.Payload
}

func (o *PutEftsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(ops_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
