// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package authority

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetAuthoritiesParams creates a new GetAuthoritiesParams object
// with the default values initialized.
func NewGetAuthoritiesParams() *GetAuthoritiesParams {
	var ()
	return &GetAuthoritiesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetAuthoritiesParamsWithTimeout creates a new GetAuthoritiesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetAuthoritiesParamsWithTimeout(timeout time.Duration) *GetAuthoritiesParams {
	var ()
	return &GetAuthoritiesParams{

		timeout: timeout,
	}
}

// NewGetAuthoritiesParamsWithContext creates a new GetAuthoritiesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetAuthoritiesParamsWithContext(ctx context.Context) *GetAuthoritiesParams {
	var ()
	return &GetAuthoritiesParams{

		Context: ctx,
	}
}

// NewGetAuthoritiesParamsWithHTTPClient creates a new GetAuthoritiesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetAuthoritiesParamsWithHTTPClient(client *http.Client) *GetAuthoritiesParams {
	var ()
	return &GetAuthoritiesParams{
		HTTPClient: client,
	}
}

/*GetAuthoritiesParams contains all the parameters to send to the API endpoint
for the get authorities operation typically these are written to a http.Request
*/
type GetAuthoritiesParams struct {

	/*AuthorityID
	  Taxnexus Id of the Authority to be retrieved

	*/
	AuthorityID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get authorities params
func (o *GetAuthoritiesParams) WithTimeout(timeout time.Duration) *GetAuthoritiesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get authorities params
func (o *GetAuthoritiesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get authorities params
func (o *GetAuthoritiesParams) WithContext(ctx context.Context) *GetAuthoritiesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get authorities params
func (o *GetAuthoritiesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get authorities params
func (o *GetAuthoritiesParams) WithHTTPClient(client *http.Client) *GetAuthoritiesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get authorities params
func (o *GetAuthoritiesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAuthorityID adds the authorityID to the get authorities params
func (o *GetAuthoritiesParams) WithAuthorityID(authorityID *string) *GetAuthoritiesParams {
	o.SetAuthorityID(authorityID)
	return o
}

// SetAuthorityID adds the authorityId to the get authorities params
func (o *GetAuthoritiesParams) SetAuthorityID(authorityID *string) {
	o.AuthorityID = authorityID
}

// WithLimit adds the limit to the get authorities params
func (o *GetAuthoritiesParams) WithLimit(limit *int64) *GetAuthoritiesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get authorities params
func (o *GetAuthoritiesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get authorities params
func (o *GetAuthoritiesParams) WithOffset(offset *int64) *GetAuthoritiesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get authorities params
func (o *GetAuthoritiesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetAuthoritiesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AuthorityID != nil {

		// query param authorityId
		var qrAuthorityID string
		if o.AuthorityID != nil {
			qrAuthorityID = *o.AuthorityID
		}
		qAuthorityID := qrAuthorityID
		if qAuthorityID != "" {
			if err := r.SetQueryParam("authorityId", qAuthorityID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
