// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package filing

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new filing API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for filing API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	GetFilings(params *GetFilingsParams, authInfo runtime.ClientAuthInfoWriter) (*GetFilingsOK, error)

	PostFilings(params *PostFilingsParams, authInfo runtime.ClientAuthInfoWriter) (*PostFilingsOK, error)

	PutFilings(params *PutFilingsParams, authInfo runtime.ClientAuthInfoWriter) (*PutFilingsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  GetFilings gets a list of filings

  Return a list of available Regulatory Filings
*/
func (a *Client) GetFilings(params *GetFilingsParams, authInfo runtime.ClientAuthInfoWriter) (*GetFilingsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetFilingsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getFilings",
		Method:             "GET",
		PathPattern:        "/filings",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetFilingsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetFilingsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getFilings: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostFilings creates new filings

  Create new Filings
*/
func (a *Client) PostFilings(params *PostFilingsParams, authInfo runtime.ClientAuthInfoWriter) (*PostFilingsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostFilingsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postFilings",
		Method:             "POST",
		PathPattern:        "/filings",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostFilingsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostFilingsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postFilings: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutFilings updates a filing

  Update all the fields in a Filing record identified by Taxnexus ID
*/
func (a *Client) PutFilings(params *PutFilingsParams, authInfo runtime.ClientAuthInfoWriter) (*PutFilingsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutFilingsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putFilings",
		Method:             "PUT",
		PathPattern:        "/filings",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutFilingsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutFilingsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putFilings: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
