// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package license

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// PostLicensesReader is a Reader for the PostLicenses structure.
type PostLicensesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostLicensesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostLicensesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostLicensesUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostLicensesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostLicensesNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostLicensesUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostLicensesInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostLicensesOK creates a PostLicensesOK with default headers values
func NewPostLicensesOK() *PostLicensesOK {
	return &PostLicensesOK{}
}

/*PostLicensesOK handles this case with default header values.

Taxnexus Response with License objects
*/
type PostLicensesOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.LicenseResponse
}

func (o *PostLicensesOK) Error() string {
	return fmt.Sprintf("[POST /licenses][%d] postLicensesOK  %+v", 200, o.Payload)
}

func (o *PostLicensesOK) GetPayload() *regs_models.LicenseResponse {
	return o.Payload
}

func (o *PostLicensesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.LicenseResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostLicensesUnauthorized creates a PostLicensesUnauthorized with default headers values
func NewPostLicensesUnauthorized() *PostLicensesUnauthorized {
	return &PostLicensesUnauthorized{}
}

/*PostLicensesUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type PostLicensesUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostLicensesUnauthorized) Error() string {
	return fmt.Sprintf("[POST /licenses][%d] postLicensesUnauthorized  %+v", 401, o.Payload)
}

func (o *PostLicensesUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostLicensesUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostLicensesForbidden creates a PostLicensesForbidden with default headers values
func NewPostLicensesForbidden() *PostLicensesForbidden {
	return &PostLicensesForbidden{}
}

/*PostLicensesForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostLicensesForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostLicensesForbidden) Error() string {
	return fmt.Sprintf("[POST /licenses][%d] postLicensesForbidden  %+v", 403, o.Payload)
}

func (o *PostLicensesForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostLicensesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostLicensesNotFound creates a PostLicensesNotFound with default headers values
func NewPostLicensesNotFound() *PostLicensesNotFound {
	return &PostLicensesNotFound{}
}

/*PostLicensesNotFound handles this case with default header values.

Resource was not found
*/
type PostLicensesNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostLicensesNotFound) Error() string {
	return fmt.Sprintf("[POST /licenses][%d] postLicensesNotFound  %+v", 404, o.Payload)
}

func (o *PostLicensesNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostLicensesNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostLicensesUnprocessableEntity creates a PostLicensesUnprocessableEntity with default headers values
func NewPostLicensesUnprocessableEntity() *PostLicensesUnprocessableEntity {
	return &PostLicensesUnprocessableEntity{}
}

/*PostLicensesUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostLicensesUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostLicensesUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /licenses][%d] postLicensesUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostLicensesUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostLicensesUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostLicensesInternalServerError creates a PostLicensesInternalServerError with default headers values
func NewPostLicensesInternalServerError() *PostLicensesInternalServerError {
	return &PostLicensesInternalServerError{}
}

/*PostLicensesInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostLicensesInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *PostLicensesInternalServerError) Error() string {
	return fmt.Sprintf("[POST /licenses][%d] postLicensesInternalServerError  %+v", 500, o.Payload)
}

func (o *PostLicensesInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *PostLicensesInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
