// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package submission

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/regs/regs_models"
)

// GetSubmissionsReader is a Reader for the GetSubmissions structure.
type GetSubmissionsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetSubmissionsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetSubmissionsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewGetSubmissionsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetSubmissionsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetSubmissionsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewGetSubmissionsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetSubmissionsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetSubmissionsOK creates a GetSubmissionsOK with default headers values
func NewGetSubmissionsOK() *GetSubmissionsOK {
	return &GetSubmissionsOK{}
}

/*GetSubmissionsOK handles this case with default header values.

Taxnexus Response with Submission objects
*/
type GetSubmissionsOK struct {
	AccessControlAllowOrigin string

	CacheControl string

	Payload *regs_models.SubmissionResponse
}

func (o *GetSubmissionsOK) Error() string {
	return fmt.Sprintf("[GET /submissions][%d] getSubmissionsOK  %+v", 200, o.Payload)
}

func (o *GetSubmissionsOK) GetPayload() *regs_models.SubmissionResponse {
	return o.Payload
}

func (o *GetSubmissionsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	o.Payload = new(regs_models.SubmissionResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSubmissionsUnauthorized creates a GetSubmissionsUnauthorized with default headers values
func NewGetSubmissionsUnauthorized() *GetSubmissionsUnauthorized {
	return &GetSubmissionsUnauthorized{}
}

/*GetSubmissionsUnauthorized handles this case with default header values.

Access Unauthorized, invalid API-KEY was used
*/
type GetSubmissionsUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *GetSubmissionsUnauthorized) Error() string {
	return fmt.Sprintf("[GET /submissions][%d] getSubmissionsUnauthorized  %+v", 401, o.Payload)
}

func (o *GetSubmissionsUnauthorized) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *GetSubmissionsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSubmissionsForbidden creates a GetSubmissionsForbidden with default headers values
func NewGetSubmissionsForbidden() *GetSubmissionsForbidden {
	return &GetSubmissionsForbidden{}
}

/*GetSubmissionsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type GetSubmissionsForbidden struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *GetSubmissionsForbidden) Error() string {
	return fmt.Sprintf("[GET /submissions][%d] getSubmissionsForbidden  %+v", 403, o.Payload)
}

func (o *GetSubmissionsForbidden) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *GetSubmissionsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSubmissionsNotFound creates a GetSubmissionsNotFound with default headers values
func NewGetSubmissionsNotFound() *GetSubmissionsNotFound {
	return &GetSubmissionsNotFound{}
}

/*GetSubmissionsNotFound handles this case with default header values.

Resource was not found
*/
type GetSubmissionsNotFound struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *GetSubmissionsNotFound) Error() string {
	return fmt.Sprintf("[GET /submissions][%d] getSubmissionsNotFound  %+v", 404, o.Payload)
}

func (o *GetSubmissionsNotFound) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *GetSubmissionsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSubmissionsUnprocessableEntity creates a GetSubmissionsUnprocessableEntity with default headers values
func NewGetSubmissionsUnprocessableEntity() *GetSubmissionsUnprocessableEntity {
	return &GetSubmissionsUnprocessableEntity{}
}

/*GetSubmissionsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type GetSubmissionsUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *GetSubmissionsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /submissions][%d] getSubmissionsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *GetSubmissionsUnprocessableEntity) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *GetSubmissionsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetSubmissionsInternalServerError creates a GetSubmissionsInternalServerError with default headers values
func NewGetSubmissionsInternalServerError() *GetSubmissionsInternalServerError {
	return &GetSubmissionsInternalServerError{}
}

/*GetSubmissionsInternalServerError handles this case with default header values.

Server Internal Error
*/
type GetSubmissionsInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *regs_models.Error
}

func (o *GetSubmissionsInternalServerError) Error() string {
	return fmt.Sprintf("[GET /submissions][%d] getSubmissionsInternalServerError  %+v", 500, o.Payload)
}

func (o *GetSubmissionsInternalServerError) GetPayload() *regs_models.Error {
	return o.Payload
}

func (o *GetSubmissionsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Access-Control-Allow-Origin
	o.AccessControlAllowOrigin = response.GetHeader("Access-Control-Allow-Origin")

	o.Payload = new(regs_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
