// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tax_type_account

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new tax type account API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for tax type account API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientService is the interface for Client methods
type ClientService interface {
	DeleteTypeAccounts(params *DeleteTypeAccountsParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteTypeAccountsOK, error)

	GetTaxTypeAccounts(params *GetTaxTypeAccountsParams, authInfo runtime.ClientAuthInfoWriter) (*GetTaxTypeAccountsOK, error)

	PostTaxTypeAccounts(params *PostTaxTypeAccountsParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxTypeAccountsOK, error)

	PutTaxTypeAccounts(params *PutTaxTypeAccountsParams, authInfo runtime.ClientAuthInfoWriter) (*PutTaxTypeAccountsOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
  DeleteTypeAccounts deletes a tax type accounts

  Delete Taxnexus Tax Type Accounts
*/
func (a *Client) DeleteTypeAccounts(params *DeleteTypeAccountsParams, authInfo runtime.ClientAuthInfoWriter) (*DeleteTypeAccountsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteTypeAccountsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "deleteTypeAccounts",
		Method:             "DELETE",
		PathPattern:        "/taxtypeaccounts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteTypeAccountsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteTypeAccountsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteTypeAccounts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  GetTaxTypeAccounts gets a list of tax type accounts

  Return a list of Tax Type Accounts
*/
func (a *Client) GetTaxTypeAccounts(params *GetTaxTypeAccountsParams, authInfo runtime.ClientAuthInfoWriter) (*GetTaxTypeAccountsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetTaxTypeAccountsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "getTaxTypeAccounts",
		Method:             "GET",
		PathPattern:        "/taxtypeaccounts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetTaxTypeAccountsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetTaxTypeAccountsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getTaxTypeAccounts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PostTaxTypeAccounts adds new tax type accounts

  Tax Type Accounts to be added
*/
func (a *Client) PostTaxTypeAccounts(params *PostTaxTypeAccountsParams, authInfo runtime.ClientAuthInfoWriter) (*PostTaxTypeAccountsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostTaxTypeAccountsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "postTaxTypeAccounts",
		Method:             "POST",
		PathPattern:        "/taxtypeaccounts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostTaxTypeAccountsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostTaxTypeAccountsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postTaxTypeAccounts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
  PutTaxTypeAccounts updates tax type accounts

  Update Tax Type Accounts records
*/
func (a *Client) PutTaxTypeAccounts(params *PutTaxTypeAccountsParams, authInfo runtime.ClientAuthInfoWriter) (*PutTaxTypeAccountsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPutTaxTypeAccountsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "putTaxTypeAccounts",
		Method:             "PUT",
		PathPattern:        "/taxtypeaccounts",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PutTaxTypeAccountsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PutTaxTypeAccountsOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for putTaxTypeAccounts: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
