// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package transaction

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetTransactionsParams creates a new GetTransactionsParams object
// with the default values initialized.
func NewGetTransactionsParams() *GetTransactionsParams {
	var ()
	return &GetTransactionsParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetTransactionsParamsWithTimeout creates a new GetTransactionsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetTransactionsParamsWithTimeout(timeout time.Duration) *GetTransactionsParams {
	var ()
	return &GetTransactionsParams{

		timeout: timeout,
	}
}

// NewGetTransactionsParamsWithContext creates a new GetTransactionsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetTransactionsParamsWithContext(ctx context.Context) *GetTransactionsParams {
	var ()
	return &GetTransactionsParams{

		Context: ctx,
	}
}

// NewGetTransactionsParamsWithHTTPClient creates a new GetTransactionsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetTransactionsParamsWithHTTPClient(client *http.Client) *GetTransactionsParams {
	var ()
	return &GetTransactionsParams{
		HTTPClient: client,
	}
}

/*GetTransactionsParams contains all the parameters to send to the API endpoint
for the get transactions operation typically these are written to a http.Request
*/
type GetTransactionsParams struct {

	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*TransactionID
	  Template ID

	*/
	TransactionID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get transactions params
func (o *GetTransactionsParams) WithTimeout(timeout time.Duration) *GetTransactionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get transactions params
func (o *GetTransactionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get transactions params
func (o *GetTransactionsParams) WithContext(ctx context.Context) *GetTransactionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get transactions params
func (o *GetTransactionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get transactions params
func (o *GetTransactionsParams) WithHTTPClient(client *http.Client) *GetTransactionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get transactions params
func (o *GetTransactionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get transactions params
func (o *GetTransactionsParams) WithLimit(limit *int64) *GetTransactionsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get transactions params
func (o *GetTransactionsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get transactions params
func (o *GetTransactionsParams) WithOffset(offset *int64) *GetTransactionsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get transactions params
func (o *GetTransactionsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithTransactionID adds the transactionID to the get transactions params
func (o *GetTransactionsParams) WithTransactionID(transactionID *string) *GetTransactionsParams {
	o.SetTransactionID(transactionID)
	return o
}

// SetTransactionID adds the transactionId to the get transactions params
func (o *GetTransactionsParams) SetTransactionID(transactionID *string) {
	o.TransactionID = transactionID
}

// WriteToRequest writes these params to a swagger request
func (o *GetTransactionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.TransactionID != nil {

		// query param transactionId
		var qrTransactionID string
		if o.TransactionID != nil {
			qrTransactionID = *o.TransactionID
		}
		qTransactionID := qrTransactionID
		if qTransactionID != "" {
			if err := r.SetQueryParam("transactionId", qTransactionID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
