// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package clusters

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// PostClustersReader is a Reader for the PostClusters structure.
type PostClustersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostClustersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostClustersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostClustersUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostClustersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostClustersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPostClustersUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostClustersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostClustersOK creates a PostClustersOK with default headers values
func NewPostClustersOK() *PostClustersOK {
	return &PostClustersOK{}
}

/*PostClustersOK handles this case with default header values.

Taxnexus Response with Cluster objects
*/
type PostClustersOK struct {
	Payload *sf_gate_models.ClusterResponse
}

func (o *PostClustersOK) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersOK  %+v", 200, o.Payload)
}

func (o *PostClustersOK) GetPayload() *sf_gate_models.ClusterResponse {
	return o.Payload
}

func (o *PostClustersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.ClusterResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostClustersUnauthorized creates a PostClustersUnauthorized with default headers values
func NewPostClustersUnauthorized() *PostClustersUnauthorized {
	return &PostClustersUnauthorized{}
}

/*PostClustersUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostClustersUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *PostClustersUnauthorized) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersUnauthorized  %+v", 401, o.Payload)
}

func (o *PostClustersUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostClustersUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostClustersForbidden creates a PostClustersForbidden with default headers values
func NewPostClustersForbidden() *PostClustersForbidden {
	return &PostClustersForbidden{}
}

/*PostClustersForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostClustersForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *PostClustersForbidden) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersForbidden  %+v", 403, o.Payload)
}

func (o *PostClustersForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostClustersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostClustersNotFound creates a PostClustersNotFound with default headers values
func NewPostClustersNotFound() *PostClustersNotFound {
	return &PostClustersNotFound{}
}

/*PostClustersNotFound handles this case with default header values.

Resource was not found
*/
type PostClustersNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *PostClustersNotFound) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersNotFound  %+v", 404, o.Payload)
}

func (o *PostClustersNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostClustersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostClustersUnprocessableEntity creates a PostClustersUnprocessableEntity with default headers values
func NewPostClustersUnprocessableEntity() *PostClustersUnprocessableEntity {
	return &PostClustersUnprocessableEntity{}
}

/*PostClustersUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PostClustersUnprocessableEntity struct {
	Payload *sf_gate_models.Error
}

func (o *PostClustersUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PostClustersUnprocessableEntity) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostClustersUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostClustersInternalServerError creates a PostClustersInternalServerError with default headers values
func NewPostClustersInternalServerError() *PostClustersInternalServerError {
	return &PostClustersInternalServerError{}
}

/*PostClustersInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostClustersInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *PostClustersInternalServerError) Error() string {
	return fmt.Sprintf("[POST /clusters][%d] postClustersInternalServerError  %+v", 500, o.Payload)
}

func (o *PostClustersInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostClustersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
