// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// PostContactsReader is a Reader for the PostContacts structure.
type PostContactsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostContactsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostContactsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostContactsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostContactsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostContactsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostContactsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostContactsOK creates a PostContactsOK with default headers values
func NewPostContactsOK() *PostContactsOK {
	return &PostContactsOK{}
}

/*PostContactsOK handles this case with default header values.

An array of Contact objects
*/
type PostContactsOK struct {
	Payload *sf_gate_models.ContactResponse
}

func (o *PostContactsOK) Error() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsOK  %+v", 200, o.Payload)
}

func (o *PostContactsOK) GetPayload() *sf_gate_models.ContactResponse {
	return o.Payload
}

func (o *PostContactsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.ContactResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContactsUnauthorized creates a PostContactsUnauthorized with default headers values
func NewPostContactsUnauthorized() *PostContactsUnauthorized {
	return &PostContactsUnauthorized{}
}

/*PostContactsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostContactsUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *PostContactsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostContactsUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostContactsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContactsForbidden creates a PostContactsForbidden with default headers values
func NewPostContactsForbidden() *PostContactsForbidden {
	return &PostContactsForbidden{}
}

/*PostContactsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostContactsForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *PostContactsForbidden) Error() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsForbidden  %+v", 403, o.Payload)
}

func (o *PostContactsForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostContactsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContactsNotFound creates a PostContactsNotFound with default headers values
func NewPostContactsNotFound() *PostContactsNotFound {
	return &PostContactsNotFound{}
}

/*PostContactsNotFound handles this case with default header values.

Resource was not found
*/
type PostContactsNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *PostContactsNotFound) Error() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsNotFound  %+v", 404, o.Payload)
}

func (o *PostContactsNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostContactsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostContactsInternalServerError creates a PostContactsInternalServerError with default headers values
func NewPostContactsInternalServerError() *PostContactsInternalServerError {
	return &PostContactsInternalServerError{}
}

/*PostContactsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostContactsInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *PostContactsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /contacts][%d] postContactsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostContactsInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostContactsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
