// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package invoices

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetInvoicesParams creates a new GetInvoicesParams object
// with the default values initialized.
func NewGetInvoicesParams() *GetInvoicesParams {
	var ()
	return &GetInvoicesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetInvoicesParamsWithTimeout creates a new GetInvoicesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetInvoicesParamsWithTimeout(timeout time.Duration) *GetInvoicesParams {
	var ()
	return &GetInvoicesParams{

		timeout: timeout,
	}
}

// NewGetInvoicesParamsWithContext creates a new GetInvoicesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetInvoicesParamsWithContext(ctx context.Context) *GetInvoicesParams {
	var ()
	return &GetInvoicesParams{

		Context: ctx,
	}
}

// NewGetInvoicesParamsWithHTTPClient creates a new GetInvoicesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetInvoicesParamsWithHTTPClient(client *http.Client) *GetInvoicesParams {
	var ()
	return &GetInvoicesParams{
		HTTPClient: client,
	}
}

/*GetInvoicesParams contains all the parameters to send to the API endpoint
for the get invoices operation typically these are written to a http.Request
*/
type GetInvoicesParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*Active
	  Retrieve only active records?

	*/
	Active *bool
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*InvoiceID
	  Taxnexus Id of the Invoice to be retrieved

	*/
	InvoiceID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get invoices params
func (o *GetInvoicesParams) WithTimeout(timeout time.Duration) *GetInvoicesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get invoices params
func (o *GetInvoicesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get invoices params
func (o *GetInvoicesParams) WithContext(ctx context.Context) *GetInvoicesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get invoices params
func (o *GetInvoicesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get invoices params
func (o *GetInvoicesParams) WithHTTPClient(client *http.Client) *GetInvoicesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get invoices params
func (o *GetInvoicesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get invoices params
func (o *GetInvoicesParams) WithAccountID(accountID *string) *GetInvoicesParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get invoices params
func (o *GetInvoicesParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithActive adds the active to the get invoices params
func (o *GetInvoicesParams) WithActive(active *bool) *GetInvoicesParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get invoices params
func (o *GetInvoicesParams) SetActive(active *bool) {
	o.Active = active
}

// WithCompanyID adds the companyID to the get invoices params
func (o *GetInvoicesParams) WithCompanyID(companyID *string) *GetInvoicesParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get invoices params
func (o *GetInvoicesParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithInvoiceID adds the invoiceID to the get invoices params
func (o *GetInvoicesParams) WithInvoiceID(invoiceID *string) *GetInvoicesParams {
	o.SetInvoiceID(invoiceID)
	return o
}

// SetInvoiceID adds the invoiceId to the get invoices params
func (o *GetInvoicesParams) SetInvoiceID(invoiceID *string) {
	o.InvoiceID = invoiceID
}

// WithLimit adds the limit to the get invoices params
func (o *GetInvoicesParams) WithLimit(limit *int64) *GetInvoicesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get invoices params
func (o *GetInvoicesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get invoices params
func (o *GetInvoicesParams) WithOffset(offset *int64) *GetInvoicesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get invoices params
func (o *GetInvoicesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetInvoicesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.Active != nil {

		// query param active
		var qrActive bool
		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {
			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.InvoiceID != nil {

		// query param invoiceId
		var qrInvoiceID string
		if o.InvoiceID != nil {
			qrInvoiceID = *o.InvoiceID
		}
		qInvoiceID := qrInvoiceID
		if qInvoiceID != "" {
			if err := r.SetQueryParam("invoiceId", qInvoiceID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
