// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package jobs

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// PutJobsReader is a Reader for the PutJobs structure.
type PutJobsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PutJobsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPutJobsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPutJobsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPutJobsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPutJobsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewPutJobsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPutJobsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPutJobsOK creates a PutJobsOK with default headers values
func NewPutJobsOK() *PutJobsOK {
	return &PutJobsOK{}
}

/*PutJobsOK handles this case with default header values.

Taxnexus Response with Job objects
*/
type PutJobsOK struct {
	Payload *sf_gate_models.JobResponse
}

func (o *PutJobsOK) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsOK  %+v", 200, o.Payload)
}

func (o *PutJobsOK) GetPayload() *sf_gate_models.JobResponse {
	return o.Payload
}

func (o *PutJobsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.JobResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutJobsUnauthorized creates a PutJobsUnauthorized with default headers values
func NewPutJobsUnauthorized() *PutJobsUnauthorized {
	return &PutJobsUnauthorized{}
}

/*PutJobsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PutJobsUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *PutJobsUnauthorized) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsUnauthorized  %+v", 401, o.Payload)
}

func (o *PutJobsUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutJobsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutJobsForbidden creates a PutJobsForbidden with default headers values
func NewPutJobsForbidden() *PutJobsForbidden {
	return &PutJobsForbidden{}
}

/*PutJobsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PutJobsForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *PutJobsForbidden) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsForbidden  %+v", 403, o.Payload)
}

func (o *PutJobsForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutJobsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutJobsNotFound creates a PutJobsNotFound with default headers values
func NewPutJobsNotFound() *PutJobsNotFound {
	return &PutJobsNotFound{}
}

/*PutJobsNotFound handles this case with default header values.

Resource was not found
*/
type PutJobsNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *PutJobsNotFound) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsNotFound  %+v", 404, o.Payload)
}

func (o *PutJobsNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutJobsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutJobsUnprocessableEntity creates a PutJobsUnprocessableEntity with default headers values
func NewPutJobsUnprocessableEntity() *PutJobsUnprocessableEntity {
	return &PutJobsUnprocessableEntity{}
}

/*PutJobsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type PutJobsUnprocessableEntity struct {
	Payload *sf_gate_models.Error
}

func (o *PutJobsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *PutJobsUnprocessableEntity) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutJobsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPutJobsInternalServerError creates a PutJobsInternalServerError with default headers values
func NewPutJobsInternalServerError() *PutJobsInternalServerError {
	return &PutJobsInternalServerError{}
}

/*PutJobsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PutJobsInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *PutJobsInternalServerError) Error() string {
	return fmt.Sprintf("[PUT /jobs][%d] putJobsInternalServerError  %+v", 500, o.Payload)
}

func (o *PutJobsInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PutJobsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
