// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package purchase_orders

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetPosParams creates a new GetPosParams object
// with the default values initialized.
func NewGetPosParams() *GetPosParams {
	var ()
	return &GetPosParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetPosParamsWithTimeout creates a new GetPosParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetPosParamsWithTimeout(timeout time.Duration) *GetPosParams {
	var ()
	return &GetPosParams{

		timeout: timeout,
	}
}

// NewGetPosParamsWithContext creates a new GetPosParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetPosParamsWithContext(ctx context.Context) *GetPosParams {
	var ()
	return &GetPosParams{

		Context: ctx,
	}
}

// NewGetPosParamsWithHTTPClient creates a new GetPosParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetPosParamsWithHTTPClient(client *http.Client) *GetPosParams {
	var ()
	return &GetPosParams{
		HTTPClient: client,
	}
}

/*GetPosParams contains all the parameters to send to the API endpoint
for the get pos operation typically these are written to a http.Request
*/
type GetPosParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*Active
	  Retrieve only active records?

	*/
	Active *bool
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*PoID
	  Taxnexus Id of the Purchase Order to be retrieved

	*/
	PoID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get pos params
func (o *GetPosParams) WithTimeout(timeout time.Duration) *GetPosParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get pos params
func (o *GetPosParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get pos params
func (o *GetPosParams) WithContext(ctx context.Context) *GetPosParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get pos params
func (o *GetPosParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get pos params
func (o *GetPosParams) WithHTTPClient(client *http.Client) *GetPosParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get pos params
func (o *GetPosParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get pos params
func (o *GetPosParams) WithAccountID(accountID *string) *GetPosParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get pos params
func (o *GetPosParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithActive adds the active to the get pos params
func (o *GetPosParams) WithActive(active *bool) *GetPosParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get pos params
func (o *GetPosParams) SetActive(active *bool) {
	o.Active = active
}

// WithCompanyID adds the companyID to the get pos params
func (o *GetPosParams) WithCompanyID(companyID *string) *GetPosParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get pos params
func (o *GetPosParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithLimit adds the limit to the get pos params
func (o *GetPosParams) WithLimit(limit *int64) *GetPosParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get pos params
func (o *GetPosParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get pos params
func (o *GetPosParams) WithOffset(offset *int64) *GetPosParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get pos params
func (o *GetPosParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPoID adds the poID to the get pos params
func (o *GetPosParams) WithPoID(poID *string) *GetPosParams {
	o.SetPoID(poID)
	return o
}

// SetPoID adds the poId to the get pos params
func (o *GetPosParams) SetPoID(poID *string) {
	o.PoID = poID
}

// WriteToRequest writes these params to a swagger request
func (o *GetPosParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.Active != nil {

		// query param active
		var qrActive bool
		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {
			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.PoID != nil {

		// query param poId
		var qrPoID string
		if o.PoID != nil {
			qrPoID = *o.PoID
		}
		qPoID := qrPoID
		if qPoID != "" {
			if err := r.SetQueryParam("poId", qPoID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
