// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package quotes

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetQuotesParams creates a new GetQuotesParams object
// with the default values initialized.
func NewGetQuotesParams() *GetQuotesParams {
	var ()
	return &GetQuotesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetQuotesParamsWithTimeout creates a new GetQuotesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetQuotesParamsWithTimeout(timeout time.Duration) *GetQuotesParams {
	var ()
	return &GetQuotesParams{

		timeout: timeout,
	}
}

// NewGetQuotesParamsWithContext creates a new GetQuotesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetQuotesParamsWithContext(ctx context.Context) *GetQuotesParams {
	var ()
	return &GetQuotesParams{

		Context: ctx,
	}
}

// NewGetQuotesParamsWithHTTPClient creates a new GetQuotesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetQuotesParamsWithHTTPClient(client *http.Client) *GetQuotesParams {
	var ()
	return &GetQuotesParams{
		HTTPClient: client,
	}
}

/*GetQuotesParams contains all the parameters to send to the API endpoint
for the get quotes operation typically these are written to a http.Request
*/
type GetQuotesParams struct {

	/*AccountID
	  Taxnexus Id of the Account to be used a record retrieval

	*/
	AccountID *string
	/*AccountNumber
	  The Taxnexus Account Number of the Account to be used a record retrieval

	*/
	AccountNumber *string
	/*Active
	  Retrieve only active records?

	*/
	Active *bool
	/*CompanyID
	  Taxnexus Id of the Company to be retrieved

	*/
	CompanyID *string
	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*QuoteID
	  Taxnexus Id of the Company to be retrieved

	*/
	QuoteID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get quotes params
func (o *GetQuotesParams) WithTimeout(timeout time.Duration) *GetQuotesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get quotes params
func (o *GetQuotesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get quotes params
func (o *GetQuotesParams) WithContext(ctx context.Context) *GetQuotesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get quotes params
func (o *GetQuotesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get quotes params
func (o *GetQuotesParams) WithHTTPClient(client *http.Client) *GetQuotesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get quotes params
func (o *GetQuotesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get quotes params
func (o *GetQuotesParams) WithAccountID(accountID *string) *GetQuotesParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get quotes params
func (o *GetQuotesParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithAccountNumber adds the accountNumber to the get quotes params
func (o *GetQuotesParams) WithAccountNumber(accountNumber *string) *GetQuotesParams {
	o.SetAccountNumber(accountNumber)
	return o
}

// SetAccountNumber adds the accountNumber to the get quotes params
func (o *GetQuotesParams) SetAccountNumber(accountNumber *string) {
	o.AccountNumber = accountNumber
}

// WithActive adds the active to the get quotes params
func (o *GetQuotesParams) WithActive(active *bool) *GetQuotesParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get quotes params
func (o *GetQuotesParams) SetActive(active *bool) {
	o.Active = active
}

// WithCompanyID adds the companyID to the get quotes params
func (o *GetQuotesParams) WithCompanyID(companyID *string) *GetQuotesParams {
	o.SetCompanyID(companyID)
	return o
}

// SetCompanyID adds the companyId to the get quotes params
func (o *GetQuotesParams) SetCompanyID(companyID *string) {
	o.CompanyID = companyID
}

// WithLimit adds the limit to the get quotes params
func (o *GetQuotesParams) WithLimit(limit *int64) *GetQuotesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get quotes params
func (o *GetQuotesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get quotes params
func (o *GetQuotesParams) WithOffset(offset *int64) *GetQuotesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get quotes params
func (o *GetQuotesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQuoteID adds the quoteID to the get quotes params
func (o *GetQuotesParams) WithQuoteID(quoteID *string) *GetQuotesParams {
	o.SetQuoteID(quoteID)
	return o
}

// SetQuoteID adds the quoteId to the get quotes params
func (o *GetQuotesParams) SetQuoteID(quoteID *string) {
	o.QuoteID = quoteID
}

// WriteToRequest writes these params to a swagger request
func (o *GetQuotesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param accountId
		var qrAccountID string
		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {
			if err := r.SetQueryParam("accountId", qAccountID); err != nil {
				return err
			}
		}

	}

	if o.AccountNumber != nil {

		// query param accountNumber
		var qrAccountNumber string
		if o.AccountNumber != nil {
			qrAccountNumber = *o.AccountNumber
		}
		qAccountNumber := qrAccountNumber
		if qAccountNumber != "" {
			if err := r.SetQueryParam("accountNumber", qAccountNumber); err != nil {
				return err
			}
		}

	}

	if o.Active != nil {

		// query param active
		var qrActive bool
		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {
			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}

	}

	if o.CompanyID != nil {

		// query param companyId
		var qrCompanyID string
		if o.CompanyID != nil {
			qrCompanyID = *o.CompanyID
		}
		qCompanyID := qrCompanyID
		if qCompanyID != "" {
			if err := r.SetQueryParam("companyId", qCompanyID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.QuoteID != nil {

		// query param quoteId
		var qrQuoteID string
		if o.QuoteID != nil {
			qrQuoteID = *o.QuoteID
		}
		qQuoteID := qrQuoteID
		if qQuoteID != "" {
			if err := r.SetQueryParam("quoteId", qQuoteID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
