// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package roles

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetRolesParams creates a new GetRolesParams object
// with the default values initialized.
func NewGetRolesParams() *GetRolesParams {
	var ()
	return &GetRolesParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetRolesParamsWithTimeout creates a new GetRolesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetRolesParamsWithTimeout(timeout time.Duration) *GetRolesParams {
	var ()
	return &GetRolesParams{

		timeout: timeout,
	}
}

// NewGetRolesParamsWithContext creates a new GetRolesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetRolesParamsWithContext(ctx context.Context) *GetRolesParams {
	var ()
	return &GetRolesParams{

		Context: ctx,
	}
}

// NewGetRolesParamsWithHTTPClient creates a new GetRolesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetRolesParamsWithHTTPClient(client *http.Client) *GetRolesParams {
	var ()
	return &GetRolesParams{
		HTTPClient: client,
	}
}

/*GetRolesParams contains all the parameters to send to the API endpoint
for the get roles operation typically these are written to a http.Request
*/
type GetRolesParams struct {

	/*Limit
	  How many objects to return at one time

	*/
	Limit *int64
	/*Offset
	  How many objects to skip? (default 0)

	*/
	Offset *int64
	/*RoleID
	  Taxnexus Id of the Role to be retrieved

	*/
	RoleID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get roles params
func (o *GetRolesParams) WithTimeout(timeout time.Duration) *GetRolesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get roles params
func (o *GetRolesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get roles params
func (o *GetRolesParams) WithContext(ctx context.Context) *GetRolesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get roles params
func (o *GetRolesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get roles params
func (o *GetRolesParams) WithHTTPClient(client *http.Client) *GetRolesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get roles params
func (o *GetRolesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get roles params
func (o *GetRolesParams) WithLimit(limit *int64) *GetRolesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get roles params
func (o *GetRolesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get roles params
func (o *GetRolesParams) WithOffset(offset *int64) *GetRolesParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get roles params
func (o *GetRolesParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithRoleID adds the roleID to the get roles params
func (o *GetRolesParams) WithRoleID(roleID *string) *GetRolesParams {
	o.SetRoleID(roleID)
	return o
}

// SetRoleID adds the roleId to the get roles params
func (o *GetRolesParams) SetRoleID(roleID *string) {
	o.RoleID = roleID
}

// WriteToRequest writes these params to a swagger request
func (o *GetRolesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.RoleID != nil {

		// query param roleId
		var qrRoleID string
		if o.RoleID != nil {
			qrRoleID = *o.RoleID
		}
		qRoleID := qrRoleID
		if qRoleID != "" {
			if err := r.SetQueryParam("roleId", qRoleID); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
