// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package statements

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// PostStatementsReader is a Reader for the PostStatements structure.
type PostStatementsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostStatementsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostStatementsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewPostStatementsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostStatementsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewPostStatementsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostStatementsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewPostStatementsOK creates a PostStatementsOK with default headers values
func NewPostStatementsOK() *PostStatementsOK {
	return &PostStatementsOK{}
}

/*PostStatementsOK handles this case with default header values.

An array of Statement objects
*/
type PostStatementsOK struct {
	Payload *sf_gate_models.StatementResponse
}

func (o *PostStatementsOK) Error() string {
	return fmt.Sprintf("[POST /statements][%d] postStatementsOK  %+v", 200, o.Payload)
}

func (o *PostStatementsOK) GetPayload() *sf_gate_models.StatementResponse {
	return o.Payload
}

func (o *PostStatementsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.StatementResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostStatementsUnauthorized creates a PostStatementsUnauthorized with default headers values
func NewPostStatementsUnauthorized() *PostStatementsUnauthorized {
	return &PostStatementsUnauthorized{}
}

/*PostStatementsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type PostStatementsUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *PostStatementsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /statements][%d] postStatementsUnauthorized  %+v", 401, o.Payload)
}

func (o *PostStatementsUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostStatementsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostStatementsForbidden creates a PostStatementsForbidden with default headers values
func NewPostStatementsForbidden() *PostStatementsForbidden {
	return &PostStatementsForbidden{}
}

/*PostStatementsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type PostStatementsForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *PostStatementsForbidden) Error() string {
	return fmt.Sprintf("[POST /statements][%d] postStatementsForbidden  %+v", 403, o.Payload)
}

func (o *PostStatementsForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostStatementsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostStatementsNotFound creates a PostStatementsNotFound with default headers values
func NewPostStatementsNotFound() *PostStatementsNotFound {
	return &PostStatementsNotFound{}
}

/*PostStatementsNotFound handles this case with default header values.

Resource was not found
*/
type PostStatementsNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *PostStatementsNotFound) Error() string {
	return fmt.Sprintf("[POST /statements][%d] postStatementsNotFound  %+v", 404, o.Payload)
}

func (o *PostStatementsNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostStatementsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostStatementsInternalServerError creates a PostStatementsInternalServerError with default headers values
func NewPostStatementsInternalServerError() *PostStatementsInternalServerError {
	return &PostStatementsInternalServerError{}
}

/*PostStatementsInternalServerError handles this case with default header values.

Server Internal Error
*/
type PostStatementsInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *PostStatementsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /statements][%d] postStatementsInternalServerError  %+v", 500, o.Payload)
}

func (o *PostStatementsInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *PostStatementsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
