// Code generated by go-swagger; DO NOT EDIT.

// All Code Copyright(c) 2018-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package tenants

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/taxnexus/lib/api/sf-gate/sf_gate_models"
)

// TenantsReader is a Reader for the Tenants structure.
type TenantsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *TenantsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewTenantsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewTenantsUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewTenantsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewTenantsNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewTenantsUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewTenantsInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewTenantsOK creates a TenantsOK with default headers values
func NewTenantsOK() *TenantsOK {
	return &TenantsOK{}
}

/*TenantsOK handles this case with default header values.

Taxnexus Response with Tenant objects
*/
type TenantsOK struct {
	Payload *sf_gate_models.TenantResponse
}

func (o *TenantsOK) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsOK  %+v", 200, o.Payload)
}

func (o *TenantsOK) GetPayload() *sf_gate_models.TenantResponse {
	return o.Payload
}

func (o *TenantsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.TenantResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTenantsUnauthorized creates a TenantsUnauthorized with default headers values
func NewTenantsUnauthorized() *TenantsUnauthorized {
	return &TenantsUnauthorized{}
}

/*TenantsUnauthorized handles this case with default header values.

Access unauthorized, invalid API-KEY was used
*/
type TenantsUnauthorized struct {
	Payload *sf_gate_models.Error
}

func (o *TenantsUnauthorized) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsUnauthorized  %+v", 401, o.Payload)
}

func (o *TenantsUnauthorized) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *TenantsUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTenantsForbidden creates a TenantsForbidden with default headers values
func NewTenantsForbidden() *TenantsForbidden {
	return &TenantsForbidden{}
}

/*TenantsForbidden handles this case with default header values.

Access forbidden, account lacks access
*/
type TenantsForbidden struct {
	Payload *sf_gate_models.Error
}

func (o *TenantsForbidden) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsForbidden  %+v", 403, o.Payload)
}

func (o *TenantsForbidden) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *TenantsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTenantsNotFound creates a TenantsNotFound with default headers values
func NewTenantsNotFound() *TenantsNotFound {
	return &TenantsNotFound{}
}

/*TenantsNotFound handles this case with default header values.

Resource was not found
*/
type TenantsNotFound struct {
	Payload *sf_gate_models.Error
}

func (o *TenantsNotFound) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsNotFound  %+v", 404, o.Payload)
}

func (o *TenantsNotFound) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *TenantsNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTenantsUnprocessableEntity creates a TenantsUnprocessableEntity with default headers values
func NewTenantsUnprocessableEntity() *TenantsUnprocessableEntity {
	return &TenantsUnprocessableEntity{}
}

/*TenantsUnprocessableEntity handles this case with default header values.

Unprocessable Entity, likely a bad parameter
*/
type TenantsUnprocessableEntity struct {
	Payload *sf_gate_models.Error
}

func (o *TenantsUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *TenantsUnprocessableEntity) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *TenantsUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewTenantsInternalServerError creates a TenantsInternalServerError with default headers values
func NewTenantsInternalServerError() *TenantsInternalServerError {
	return &TenantsInternalServerError{}
}

/*TenantsInternalServerError handles this case with default header values.

Server Internal Error
*/
type TenantsInternalServerError struct {
	Payload *sf_gate_models.Error
}

func (o *TenantsInternalServerError) Error() string {
	return fmt.Sprintf("[POST /tenants][%d] tenantsInternalServerError  %+v", 500, o.Payload)
}

func (o *TenantsInternalServerError) GetPayload() *sf_gate_models.Error {
	return o.Payload
}

func (o *TenantsInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(sf_gate_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
