package types

import "database/sql"

// JournalEntry is a first class object type
type JournalEntry struct {
	ID               string
	AccountID        string
	Balanced         bool
	CreatedByID      string
	CreatedDate      sql.NullTime
	Credits          float64
	Debits           float64
	Description      string
	IngestID         string
	Items            []*JournalItem
	JournalDate      sql.NullTime
	LastModifiedByID string
	LastModifiedDate sql.NullTime
	ParentFK         string
	PeriodID         string
	Posted           bool
	Ref              string
	SalesRegulation  string
	Status           string
	TenantID         string
}
