package types

import "database/sql"

// OrderItem is a first class object type
type OrderItem struct {
	ID                  string
	Activated           bool
	ActiveatedByID      string
	AvailableQuantity   float64
	COGS                float64
	CreatedByID         string
	CreatedDate         sql.NullTime
	CreateReservation   bool
	DateDelivered       sql.NullTime
	DateOrdered         sql.NullTime
	DatePromised        sql.NullTime
	Description         string
	Discount            float64
	Family              string
	InvoiceItemID       string
	LastModifiedByID    string
	LastModifiedDate    sql.NullTime
	ListPrice           float64
	LocationID          string
	MRCInterval         int64
	OrderID             string
	OriginalOrderItemID string
	ParentFK            string
	Posted              bool
	ProductCode         string
	ProductID           string
	ProductName         string
	Quantity            float64
	QuantityOnHand      float64
	QuoteItemID         string
	Ref                 string
	ServiceDate         sql.NullTime
	ShippingHandling    float64
	Status              string
	SubscriptionID      string
	Subtotal            float64
	TaxnexusCodeDisplay string
	TaxnexusCodeID      string
	TenantID            string
	TotalPrice          float64
	UnitPrice           float64
	Units               string
}
