package types

import (
	"database/sql"
)

// Task is a first class object type
type Task struct {
	AccountID              string
	ActivityDate           sql.NullTime
	APIName                string
	Body                   string
	CallDisposition        string
	CallDurationInSeconds  int
	CallObject             string
	CallType               string
	CommentCount           int
	CreatedByID            string
	CreatedDate            sql.NullTime
	Description            string
	ID                     string
	InsertedByID           string
	IsArchived             bool
	IsClosed               bool
	IsDefault              bool
	IsHighPriority         bool
	IsRecurrence           bool
	IsReminderset          bool
	IsRichText             bool
	IsVisibleInSelfService bool
	IsWhat                 bool
	LastModifiedByID       string
	LastModifeidDate       sql.NullTime
	LikeCount              int
	LinkURL                string
	MasterLabel            string
	NetworkScope           string
	OwnerID                string
	ParentID               string
	Priority               string
	RelationID             string
	ReminderDateTime       sql.NullTime
	SortOrder              int
	Status                 string
	Subject                string
	TaskID                 string
	TaskSubtype            string
	Title                  string
	Type                   string
	Visibility             string
	WhatCount              int
	WhatID                 string
	WhoCount               int
	WhoID                  string
}
